### Function

# Gio File new_tmp

since: 2.32

#### Declaration [src]

    GFile*
    g_file_new_tmp (
      const char* tmpl,
      GFileIOStream** iostream,
      GError** error
    )

#### Description [src]

Opens a file in the preferred directory for temporary files (as returned by g_get_tmp_dir()) and returns a `GFile` and `GFileIOStream` pointing to it.

`tmpl` should be a string in the GLib file name encoding containing a sequence of six ‘X’ characters, and containing no directory components. If it is `NULL`, a default template is used.

Unlike the other `GFile` constructors, this will return `NULL` if a temporary file could not be created.

Available since: 2.32

#### Parameters

`tmpl`

  Type: `const char*`

  Template for the file name, as in g_file_open_tmp(), or `NULL` for a default template.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a platform-native string, using the preferred OS encoding on Unix and UTF-8 on Windows.

`iostream`

  Type: `GFileIOStream`

  On return, a `GFileIOStream` for the created file.

  The argument will be set by the function.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFile`

A new `GFile`. Free the returned object with g_object_unref().

The caller of the function takes ownership of the data, and is responsible for freeing it.